Skip to content
New issue

Have a question about this project? Sign up for a free GitHub account to open an issue and contact its maintainers and the community.

By clicking “Sign up for GitHub”, you agree to our terms of service and privacy statement. We’ll occasionally send you account related emails.

Already on GitHub? Sign in to your account

mako.exceptions Tries to do b"bytes".split() when rendering text_error_template, and fails (in Python 3) #209

Closed
sqlalchemy-bot opened this issue Feb 20, 2013 · 2 comments

Comments

@sqlalchemy-bot
Copy link

@sqlalchemy-bot sqlalchemy-bot commented Feb 20, 2013

Migrated issue, originally created by Anonymous

Magical combination:

  • Python 3
  • TemplateLookup being used with...
  • ...module_directory
  • Template's render() must fail (due to no such argument, for example)
  • While handling exception, do mako.exceptions.text_error_template().render()

Result:

While trying to display error template, another exception is thrown because byte-strings don't have split().

"''During handling of the above exception, another exception occurred [...snip...] for line in module_source.split("\n"):
TypeError: Type str doesn't support the buffer API''"

Work-Around:

To "fix" this, change line 170 in mako/exceptions.py from:

for line in module_source.split("\n"):

...to...

for line in module_source.decode('utf-8').split("\n"):

I believe 'utf-8' will need to be replaced with something else.


Attachments: my_template.html | mako_bug.py

@sqlalchemy-bot
Copy link
Author

@sqlalchemy-bot sqlalchemy-bot commented Feb 20, 2013

Michael Bayer (@zzzeek) wrote:

thanks! I was able to reproduce this with our own fixtures. 779e1f3 fixes it, give it a try and let me know. I might call this release 0.8.0.

@sqlalchemy-bot
Copy link
Author

@sqlalchemy-bot sqlalchemy-bot commented Feb 20, 2013

Changes by Michael Bayer (@zzzeek):

  • removed labels: easy
  • changed status to closed
Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment
Projects
None yet
Linked pull requests

Successfully merging a pull request may close this issue.

None yet
1 participant
You can’t perform that action at this time.